/*
 * Copyright (c) 2015 ezivkoc
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

package wa.server.page;

import wa.server.WAContext;
import wa.server.plugin.WAConfigEntry;
import wa.server.plugin.WAServiceConfig;
import zutil.io.file.FileUtil;
import zutil.log.LogUtil;
import zutil.net.http.HttpHeader;
import zutil.parser.DataNode;
import zutil.parser.Templator;
import zutil.ui.Configurator;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * A dynamic configuration page where a list of the same
 * Bean type can be configured
 *
 * Created by Ziver on 2015-07-27.
 */
public class ConfigPage implements WAPage{
    private static final Logger log = LogUtil.getLogger();
    private static final String TMPL_FILE = "WebContent/page/ConfigPage.tmpl";

    private WAServiceConfig config;


    public ConfigPage(WAServiceConfig conf) {
        this.config = conf;
    }


    @Override
    public Templator htmlResponse(WAContext context,
                                  HttpHeader client_info,
                                  Map<String, Object> session,
                                  Map<String, String> cookie,
                                  Map<String, String> request) {
        try {
            List<?> confObjs = config.getConfigData();
            ArrayList<Configurator<WAConfigEntry>> confList = new ArrayList<>();
            for(Object obj : confObjs){
                confList.add(new Configurator(obj));
            }

            // Actions
            int index = Integer.parseInt(request.get("id"));
            Configurator<WAConfigEntry> target = findObj(confList, index);
            switch (request.get("action")){
                case "create":
                    target = new Configurator(config.createConfig());
                case "modify":
                    for(Configurator.ConfigurationParam param : target.getConfiguration()){
                        if(request.containsKey(param.getName()))
                            param.setValue(request.get(param.getName()));
                    }
                    target.applyConfiguration();
                    break;
                case "delete":
                    config.deleteConfig(index);
                    break;
                case "enable":
                    target.getObject().setEnabled(true);
                    break;
                case "disable":
                    target.getObject().setEnabled(false);
                    break;
            }

            // Prepare Output
            Templator tmpl = new Templator(FileUtil.find(TMPL_FILE));
            tmpl.set("params", Configurator.getConfiguration(
                    config.getConfigClass()));
            tmpl.set("data", confList);
            return tmpl;
        } catch (IOException e) {
            log.log(Level.SEVERE, null, e);
        }
        return null;
    }

    @Override
    public DataNode jsonResponse(WAContext context,
                                 HttpHeader client_info,
                                 Map<String, Object> session,
                                 Map<String, String> cookie,
                                 Map<String, String> request) {
        return null;
    }


    private static Configurator<WAConfigEntry> findObj(List<Configurator<WAConfigEntry>> list, int id){
        for (Configurator<WAConfigEntry> conf : list) {
            if(conf.getObject().getId() == id)
                return conf;
        }
        return null;
    }
}
